package ex3;

import javax.swing.*;
import java.awt.*;
import java.util.*;

public class Drawing extends JPanel {

	private static final long serialVersionUID = 1L;
	
	//liste des points du dessin
	ArrayList<PaintedPoint> points;
	
	public Drawing(){
		super();
		points = new ArrayList<PaintedPoint>();
	}
	
	public void addPoint(PaintedPoint p){
		points.add(p);
	}
	
	//dessine la dernire ligne  dessiner
	public void update(){
		if(points.size()>1){
			PaintedPoint lastPoint = points.get(points.size()-2);
			PaintedPoint currentPoint = points.get(points.size()-1);
			if(currentPoint.isPainted() && lastPoint.isPainted()){
				this.getGraphics().drawLine((int)lastPoint.getX(), (int)lastPoint.getY(), 
						(int)currentPoint.getX(), (int)currentPoint.getY());
			}
		}
	}
	
	/**
	 * Dessine tout le dessin.
	 * 
	 * Mthode de JFrame redfinie : dessine tout le dessin sur le Graphics donn.
	 * va tre appel automatiquement par exemple lors du redimensionnement de la 
	 * zone
	 */
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		if(points.size()>0){
			PaintedPoint lastPoint = points.get(0);
			for(int i=1; i<points.size(); i++){
				PaintedPoint currentPoint = points.get(i);
				if(lastPoint.isPainted()){
					g.drawLine((int)lastPoint.getX(), (int)lastPoint.getY(), 
							(int)currentPoint.getX(), (int)currentPoint.getY());
				}
				lastPoint = currentPoint;
			}
		}
	}
	
	/**
	 * Efface le dessin.
	 */
	public void clear(){
		points.clear();
	}
	
	
}
